<?

 /**********************************************************************************************
 * Filename: backend.php
 *
 * This file is part of the System statistics JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The System statistics JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/system_statistics/
 **********************************************************************************************/


 require_once($_path["include"]."data.php");
 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."history.php");
 require_once($_path["include"]."toolkit.php");

 class Plugin_Backend_system_statistics extends Base_Plugin_Backend
 {
  function main()
  {
   $this->tk=new Toolkit();
   unset($this->tk->e);
   $this->tk->e=&$this->e;

   return true;
  }

  function output()
  {
   global $_path;

   $output="";

   if(request("cms"))
    $output.=$this->cms();
   else
   {
    if(request("run"))
    {
     require_once($this->plugin->path["root"]."ss.php");
     $ss=new SystemStatistics(request("run"));

     if($ss->e->any("fatal")||!$ss->gather())
      $this->e->add($ss->e);
     else
      $this->e->add("Run successful", "note");
    }

    $output.=$this->overview();
   }

   return $output;
  }

  function overview()
  {
   global $_path;

   require_once($this->plugin->path["root"]."ss.php");
   $ss=new SystemStatistics("");

   $d=Data::cache("system_statistics_pluginConfigs", "view", "all");
   $d->setValue("plugin", $this->plugin->name);
   $d->sortOrder("key");
   $d->get(1);

   $r="";

   if($this->e->any())
    $r.=$this->e->show();

   $r.="<h3>Cron</h3>\n<ul class=\"list decimal\">";
   $r.="<li>gather.php can be found in: \"jas/".$this->plugin->path["root"]."\"</li>\n";
   $r.="<li>gather.php can be call with --all to run all configured System Statistics jobs</li>\n";
   $r.="<li>Cronjob example running all jobs every 5 minutes:<br/> */5 * * * * php ".$_SERVER["DOCUMENT_ROOT"]."/jas/".$this->plugin->path["root"]."gather.php --all 2>/dev/null</li>\n";
   $r.="<li>Make sure you run the cronjobs as the same user running the webserver when using SSH. The SSH keys are only accessible by this user.</li>\n";
   $r.="</ul><br/>\n";

   $r.="<h2>".$d->title.($d->r("add")?" <a href=\"".$this->plugin->url()."cms=1&amp;a=add&amp;m=".$d->module."&amp;plugin[0]=".$this->plugin->name."\" title=\"Add ".$d->title."\">".$this->tk->icon("add", "small")."</a>\n":"")."</h2>\n";
   $r.="<div class=\"configs\">\n";

   while($d->next())
   {
    $r.="<div class=\"config\">";
    $r.="<h3>".$d->v["key"].($d->v["server"]["name"]?" (".$d->v["server"]["name"].")":"")."</h3>";

    if($d->v["load"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("load")."</div><div class=\"input\">Yes</div></div>\n";
    if($d->v["networkDevices"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("networkDevices")."</div><div class=\"input\">".join(", ", $d->v["networkDevices"])."</div></div>\n";
    if($d->v["diskspaceDevices"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("diskspaceDevices")."</div><div class=\"input\">".join(", ", $d->v["diskspaceDevices"])."</div></div>\n";
    if($d->v["diskstatsDevices"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("diskstatsDevices")."</div><div class=\"input\">".join(", ", $d->v["diskstatsDevices"])."</div></div>\n";
    if($d->v["sensorsDevices"])
     $r.="<div class=\"field\"><div class=\"title\">".$d->title("sensorsDevices")."</div><div class=\"input\">".join(", ", $d->v["sensorsDevices"])."</div></div>\n";

    $r.="<div class=\"field\"><div class=\"title\">Cron job</div><div class=\"input\">php gather.php \"".$d->v["key"]."\"</div></div>\n";

    if($d->v["server"]["method"]=="SNMP")
     $r.="<div class=\"field\"><div class=\"title\">SNMP</div><div class=\"input\">".$d->v["server"]["username"]."@".$d->v["server"]["hostname"].":".$d->v["server"]["port"]."</div></div>\n";
    else if($d->v["server"]["method"]=="SSH")
     $r.="<div class=\"field\"><div class=\"title\">SSH</div><div class=\"input\">".$d->v["server"]["username"]."@".$d->v["server"]["hostname"].":".$d->v["server"]["port"]."</div></div>\n";

    $r.="<div class=\"cmsOptions\">\n";
    $r.="<a href=\"".$this->tk->url("plugins/".$this->plugin->name."/frontend/", Array("config" => $d->v["key"]))."\" title=\"Graph: ".$d->v["key"]."\">".$this->tk->icon("graph", "small")."</a>\n";
    $r.="<a href=\"".$this->plugin->url()."run=".$d->v["key"]."\" title=\"Run: ".$d->v["key"]."\">".$this->tk->icon("execute", "small")."</a>\n";
    if($d->r("edit")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=edit&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Edit: ".$d->v["key"]."\">".$this->tk->icon("edit", "small")."</a>\n";
    if($d->r("move")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=move&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Move: ".$d->v["key"]."\">".$this->tk->icon("move", "small")."</a>\n";
    if($d->r("delete")) $r.="<a href=\"".$this->plugin->url()."cms=1&amp;a=delete&amp;m=".$d->module."&amp;nr=".$d->v["nr"]."\" title=\"Delete: ".$d->v["key"]."\">".$this->tk->icon("delete", "small")."</a>\n";
    $r.="</div>\n";

    $r.="<br/><br/></div>\n";
   }

   $r.="</div>\n";

   return $r;
  }

  function cms()
  {
   $cms=new CMS();

   $hs=new History();
   $hs->cms();

   $cms->addVar("cms", 1);
   foreach($this->plugin->vars as $k => $v)
    $cms->addVar($k, $v);

   $cms->setData(new Data());
   $r=$cms->form();

   return $r;
  }

 }

?>
