<?

 /**********************************************************************************************
 * Filename: modules/diskspace.php
 *
 * This file is part of the System statistics JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The System statistics JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/system_statistics/
 **********************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_system_statistics_diskspace extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Disk space system statistics";

   $this->data->defaultFields("id");

   $this->data->addField("keynr", "nr", "all", "reload", 1, false, 0, "Device");
   $this->data->addReference("keynr", "system_statistics_keys", "nr", "*:1");

   $this->data->addField("total", "nr", "all", "big", 0, false, 0, "Total bytes");
   $this->data->addField("used", "nr", "all", "big", 0, false, 0, "Bytes used");
   $this->data->addField("available", "nr", "all", "big", 0, false, 0, "Bytes available");
   $this->data->addField("timestamp", "datetime", "all", "title", false, false, "now", "Timestamp");

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256);

   $this->data->addIndex("keynr", "keynr");

   $this->data->sortOrder("timestamp-");
  }
 }
?>
