<?

 /**********************************************************************************************
 * Filename: modules/keys.php
 *
 * This file is part of the System statistics JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The System statistics JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/system_statistics/
 **********************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_system_statistics_keys extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="System statistics keys";

   $this->data->defaultFields("id;updated");

   $this->data->addField("key", "text", "all", "title", 1, 50, "", "Key");
   $this->data->addField("keypath", "text", "show", "title", 0, false, "", "Key path");
   $this->data->addField("unit", "text", "all", "title", 0, 25, "", "Unit");
   $this->data->addField("info", "text", "all", "title", 0, 255, "", "Additional info");

   $this->data->addField("keynr", "nr", "all", "", 0, false, 0, "Parent key");
   $this->data->addReference("keynr", "system_statistics_keys", "nr", "*:0");

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256);

   $this->data->sortOrder("key");
  }

  function treePreGet(){return $this->viewPreGet();}
  function viewPreGet()
  {
   if($this->data->check("use", "show", "keypath")) //get key path
   {
    if(!$this->data->check("use", "show", "keynr"))
     $this->data->field["keynr"]["use"].=";show";

    if(!$this->data->check("use", "show", "key"))
     $this->data->field["key"]["use"].=";show";
   }

   return true;
  }

  function viewPostGet(){return $this->keyPaths(0);}
  function treePostGet(){return $this->keyPaths(0);}

  function keyPaths($keynr, $path="")
  {
   if($this->data->action=="view"&&$this->data->extra=="info")
    return true;

   for($c=0;$c<$this->data->vmax;$c++)
   {
    if($this->data->field["keynr"]["value"][$c]==$keynr)
    {
     if(!$path)
      $this->data->field["keypath"]["value"][$c]=$this->data->field["key"]["value"][$c];
     else
      $this->data->field["keypath"]["value"][$c]=$path."->".$this->data->field["key"]["value"][$c];

     $this->keyPaths($this->data->field["nr"]["value"][$c], $this->data->field["keypath"]["value"][$c]);
    }
   }

   return true;
  }
 }
?>
