<?

 /**********************************************************************************************
 * Filename: modules/load.php
 *
 * This file is part of the System statistics JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The System statistics JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/system_statistics/
 **********************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_system_statistics_load extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Load system statistics";

   $this->data->defaultFields("id");

   $this->data->addField("keynr", "nr", "all", "reload", 1, false, 0, "Key");
   $this->data->addReference("keynr", "system_statistics_keys", "nr", "*:1");

   $this->data->addField("users", "nr", "all", "", 0, false, 0, "Users");

   $this->data->addField("load1", "float", "all", "", 0, false, 0, "Average load 1 minute");
   $this->data->addField("load5", "float", "all", "", 0, false, 0, "Average load 5 minutes");
   $this->data->addField("load15", "float", "all", "", 0, false, 0, "Average load 15 minutes");
   $this->data->addField("activeprocs", "nr", "all", "", 0, false, 0, "Active processes");
   $this->data->addField("totalprocs", "nr", "all", "", 0, false, 0, "Total processes");

   $this->data->addField("timestamp", "datetime", "all", "title", 0, false, "now", "Timestamp");
   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256);

   $this->data->addIndex("keynr", "keynr");

   $this->data->sortOrder("timestamp-");
  }
 }
?>
