<?

 /**********************************************************************************************
 * Filename: modules/pluginConfigs.php
 *
 * This file is part of the System statistics JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The System statistics JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/system_statistics/
 **********************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_system_statistics_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="System statistics plugin configuration";

   $this->data->addField("width", "nr", "all", "", 10, 1600, 800, "Graph width");
   $this->data->addField("height", "nr", "all", "", 10, 1200, 600, "Graph height");

   $this->data->addField("server", "nr", "all", "reload", 1, false, false, "Dashboard server");
   $this->data->addReference("server", "dashboard_servers", "nr", "*:1");

   $this->data->addField("load", "boolean", "all", "", false, false, false, "System load");
   $this->data->addField("networkDevices", "multilist", "all", "", 0, 65536, "", "Network devices");
   $this->data->addField("diskspaceDevices", "multilist", "all", "", 0, 65536, "", "Disk space devices");
   $this->data->addField("diskstatsDevices", "multilist", "all", "", 0, 65536, "", "Disk statistics devices");
   $this->data->addField("sensorsDevices", "multilist", "all", "", 0, 65536, "", "Sensors");

   $this->data->group("Gather", "server", "load", "networkDevices", "diskspaceDevices", "diskstatsDevices", "sensorsDevices");
  }

  function postInit()
  {
   if($this->data->action!="add"&&$this->data->action!="edit")
    return true;

   return $this->customizeFields();
  }
  function addPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   if($this->data->vmax==0&&($this->data->action!="add"||$this->data->extra=="copy")) //only change fields if object has data or if add new
    return true;

   if($this->data->vmax)
    $max=$this->data->vmax;
   else
    $max=1;

   for($c=0;$c<$max;$c++)
    $this->data->setValue("plugin", "system_statistics", $c);

   if($this->data->getValue("server"))
   {
    $modules=Array("network", "diskspace", "diskstats", "sensors");

    $d=Data::cache("dashboard_servers", "view", "item");
    $d->setValue("nr", $this->data->getValue("server"));
    $d->setShowFields("networkDevices", "diskspaceDevices", "diskstatsDevices", "sensorsDevices");

    if(!$d->get())
    {
     $this->data->e->add($d->e);
     return false;
    }

    foreach($modules as $module)
    {
     if($options=$d->getValue($module."Devices"))
     {
      $this->data->resetField($module."Devices");
      $this->data->listOptions($module."Devices", $options);
     }
     else
      $this->data->field[$module."Devices"]["properties"].=";hidden";
    }
   }

   return true;
  }

 }
?>
